// Message view  scripts

function ScrollOn() {
  allowScroll = true;
  tempFreeze=false;
  pageScroll();
}

var tempFreeze=false;

function scroll() {
    window.scrollTo(0, document.body.scrollHeight);
    isScrolling = true;
    ScrollOn();  
}

var allowScroll = true;
var isScrolling=false;
function pageScroll() {
    if (allowScroll && !tempFreeze) {
       isScrolling = true; 
       window.scrollBy(0,150); // horizontal and vertical scroll increments
       scrolldelay = setTimeout('pageScroll()',100); // scrolls every 100 milliseconds
    }
}

document.onscroll=function(e) {
    if (!isScrolling)
       app.scrolling();
    isScrolling = false;
};

function scrolltobottom() {
    // Scroll once to bottom of page
    window.scrollTo(0, document.body.scrollHeight); 
    //setTimeout('window.scrollBy(0,500)',50); // try to scroll some more
}

window.onload = function() {
  app.setup();
};

var autosend=false;
var stopGifs=false;

 function addLine(line) {
     
   var content=document.getElementById('content');
   var newline=document.createElement('div');
   newline.innerHTML=line;
   content.appendChild(newline);
   scroll();
   redirectLinks();
   limitImageSize();
   repaint();
   if (stopGifs) setTimeout('stopGifAnimations()',3000);
}

function setConversation(line) {
   var content=document.getElementById('content');
   var newline=document.createElement('div');
   newline.innerHTML=line;
   content.appendChild(newline);
   redirectLinks();
   limitImageSize();
   if (stopGifs) setTimeout('stopGifAnimations()',3000);
   scroll();
   //setTimeout('window.scrollTo(0, document.body.scrollHeight)',3000); 
}

function limitImageSize() {
    $("img").addClass("limit-size");
}

function insertHTML(str) {
    var newElem = document.createElement ("span"); 
    newElem.innerHTML = str;
    var sel = window.getSelection();
    var range = sel.getRangeAt(0);
    range.insertNode(newElem);  
    range.selectNodeContents(newElem);
 
    range.collapse(false);
    sel.removeAllRanges();
    sel.addRange(range);
}

function repaint() {
    var content=document.getElementById('content');
    content.style.display = 'inline-block';
    content.offsetHeight;
    content.style.display = 'block';
}

function loadCSS(css) {
     $('head > link').filter(':first').attr('href', css+'.css'); 
}

function redirectLinks() {
     
    // intercept all links
    var handler = function(){
           if(this.href.indexOf("javascript:void(0)")===0) return true;
           if(this.href.indexOf("javascript:ft")===0 )  return true;
           if(this.href.indexOf("javascript:app.")===0 )  return true;
           
           app.click(this.href);
           app.log("redirectLinks: redirected: "+this.href);
           return false;
       };

   for (var ls = document.links, numLinks = ls.length, i=0; i<numLinks; i++){
       if(ls[i].href.indexOf("javascript:void(7)")!==0)
            ls[i].onclick= handler;
   }
   
    var formsCollection = document.getElementsByTagName("form");
    for(var i=0;i<formsCollection.length;i++)
    {
       
       formsCollection[i].onsubmit = function( e ) {
            app.log("formsCollection[i].onsubmit called"); 
            e.stopPropagation();
            e.preventDefault(); 
        };
    }    
}

var closepaste = false;

document.onpaste=function(e) {
    if (closepaste || app.checkclipboard(document.body.innerHTML)) {
        app.log("DOCUMENT unathorized paste attempt detected: preventing");
        e.stopPropagation();
        e.preventDefault(); 
    }  
    else setTimeout('redirectLinks()',100); 
};


document.onkeypress=function(evnt){
     
    var charCode = (evnt.charCode || evnt.charCode === 0) ? evnt.charCode : ((evnt.keyCode) ? evnt.keyCode : evnt.which);
    if (charCode === 13 && autosend && !evnt.shiftKey) {        
        app.sendtext();
        evnt.preventDefault();  // this was a tricky issue to catch :)
    } else {
        if( app.checktext(document.body.innerHTML, String.fromCharCode(charCode))) {
            evnt.preventDefault();            
        }  
    }    
};

document.onkeydown=function(evnt){
    if( app.checkspecial(document.body.innerHTML, evnt.keyCode)) {
        evnt.preventDefault(); 
    }  
      
};


function chatReplace(str1, str2) {
    
    var len = str1.length;   
    var newElem = document.createTextNode(str2);
    
    
    var sel = window.getSelection();
    var range = sel.getRangeAt(0);
    range.collapse(false);
    range.setStart(range.startContainer, range.endOffset-len+1);
    range.deleteContents();
    range.insertNode(newElem);

    range = range.cloneRange();
    range.selectNodeContents(newElem);
    range.collapse(false);
    sel.removeAllRanges();
    sel.addRange(range);
}

function chatImageReplace(str1, img) {
    
    var len = str1.length;   
    var sel = window.getSelection();
    var range = sel.getRangeAt(0);
    range.collapse(false);
    range.setStart(range.startContainer, range.endOffset-len+1);
    range.deleteContents();
    addImage(img);
}

function getSelectedhtml() {
    var sel = window.getSelection();
    var range = sel.getRangeAt(0);
    var frag = range.cloneContents();
    var div = document.createElement("div");
    div.appendChild(frag);
    return div.innerHTML;
}

function getCaretCharacterOffsetWithin(element) {
    var caretOffset = 0;
    
    var range = window.getSelection().getRangeAt(0);
    var preCaretRange = range.cloneRange();
    preCaretRange.selectNodeContents(element);
    preCaretRange.setEnd(range.endContainer, range.endOffset);
    caretOffset = preCaretRange.toString().length;
    return caretOffset;
}     
  
  
function setcurline(line) {
  document.body.innerHTML=line; 
}

function getcurline() {
  return document.body.innerHTML;  
}

function gethtml() {
  var html = document.body.innerHTML;
  // Clear editor
  document.body.innerHTML = "";
//  while(document.body.childNodes.length >0)
//     document.body.removeChild(document.body.firstChild);
  // prepare the color/font for next line
  SetInitialFont();
  closepaste = false;
  return html;
}

function isSelected() {
    var sel = window.getSelection();
    return sel.toString()!=='';
}

function SetInitialFont() {
    var newElem = document.createElement ("div"); //span");
    newElem.innerHTML = "\u200b"; // Zero width Space
    
    if (savedSize)
        newElem.style.fontSize = savedSize+"px";
    if (savedcolor)
        newElem.style.color = savedcolor;
    if (savedBold)
       newElem.style.fontWeight = savedBold;
    if (savedStyle)
        newElem.style.fontStyle = savedStyle;
    
    document.body.appendChild(newElem);   
    var rangeObj = document.createRange();
    rangeObj.selectNode(newElem);
    var sel = window.getSelection();
    sel.addRange(rangeObj);
    // Place caret at end
    var range = document.createRange();
    range.selectNodeContents(newElem);
    range.collapse(false);
    sel.removeAllRanges();
    sel.addRange(range);
}

function setBackgroundColor(color) {
  document.bgColor = color;
}

var savedSize;

function SetFontSize(size) {
   
   var sel = window.getSelection();
   if (sel.rangeCount) {
        var range = sel.getRangeAt(0);
        if (range.toString().length>0) {
                savedSize = size;
                applyFontSizeToSelection(size);
                range.collapse(false);
                // set caret at end
                range = document.createRange();
                range.selectNodeContents(document.body.lastChild);
                range.collapse(false);
                sel.removeAllRanges();
                sel.addRange(range);
        } else {
                var newElem = document.createElement ("span");
                newElem.innerHTML = "\u200b"; // Zero width Space
                newElem.style.fontSize = size+"px";
                range.insertNode(newElem);
                range.selectNodeContents(newElem);
                range.collapse(false);
                sel.removeAllRanges();
                sel.addRange(range);
        }
    }
}

var savedBold;

function SetFontBold(weight) {
   
   
   var sel = window.getSelection();
   if (sel.rangeCount) {
        var range = sel.getRangeAt(0);
        if (range.toString().length>0) {
                applyClassToSelection(weight==800?'fontbold':'fontthin');
                range.collapse(false);
                // set caret at end
                range = document.createRange();
                range.selectNodeContents(document.body.lastChild);
                range.collapse(false);
                sel.removeAllRanges();
            sel.addRange(range);
        } else {
                savedBold = weight;
                var newElem = document.createElement ("span");
                newElem.innerHTML = "\u200b"; // Zero width Space
                newElem.style.fontWeight = weight;
                range.insertNode(newElem);
                range.collapse(false);
                sel.removeAllRanges();
                sel.addRange(range);
        }
    }
}

var savedStyle;

function SetFontStyle(style) {
   
   var sel = window.getSelection();
   if (sel.rangeCount) {
        var range = sel.getRangeAt(0);
        if (range.toString().length>0) {
            applyClassToSelection(style==='normal'?'fontnormal':'fontitalic');
            range.collapse(false);
            // set caret at end
            range = document.createRange();
            range.selectNodeContents(document.body.lastChild);
            range.collapse(false);
            sel.removeAllRanges();
            sel.addRange(range);
        } else {
            savedStyle = style;
            var newElem = document.createElement ("span");
            newElem.innerHTML = "\u200b"; // Zero width Space
            newElem.style.fontStyle = style;
            range.insertNode(newElem);
            range.collapse(false);
            sel.removeAllRanges();
            sel.addRange(range);
        }
    }
}


var savedcolor;

function SetFontColor(color) {
   
   var sel = window.getSelection();
   if (sel.rangeCount) {
        var range = sel.getRangeAt(0);
        if (range.toString().length>0) {
                applyFontColorToSelection(color);
                range.collapse(false);
                // set caret at end
                range = document.createRange();
                range.selectNodeContents(document.body.lastChild);
                range.collapse(false);
                sel.removeAllRanges();
                sel.addRange(range);
        } else {
                savedcolor = color;
                var newElem = document.createElement ("span");
                newElem.innerHTML = "\u200b"; // Zero width Space
                newElem.style.color = color;
                range.insertNode(newElem);
                range.collapse(false);
                sel.removeAllRanges();
                sel.addRange(range);
        }
    }
}

function addImage(img) {
    if (closepaste) return;
    var newimg=document.createElement('a');
    newimg.innerHTML=img;
    insertNodeAtCaret(newimg);
    return;
}

function addImageLink(img, link, title) {
    if (closepaste) return;
    var newimg=document.createElement("a");
    newimg.setAttribute("href", link);
    newimg.setAttribute("title", title);
    newimg.innerHTML=img;
    insertNodeAtCaret(newimg);
    return;
}

function setupEditor() {
    //app.log("setting up!"); 
    document.getElementById('editor').focus();
    gethtml();
}


function insertNodeAtCaret(node) {
    var sel = window.getSelection();
    if (sel.rangeCount) {
        var range = sel.getRangeAt(0);
        range.collapse(false);
        range.insertNode(node);

        range = range.cloneRange();
        range.selectNodeContents(node);
        range.collapse(false);
        sel.removeAllRanges();
        sel.addRange(range);
    }
}

var rangeIntersectsNode = (typeof window.Range !== "undefined"
        && Range.prototype.intersectsNode) ?

    function(range, node) {
        return range.intersectsNode(node);
    } :

    function(range, node) {
        var nodeRange = node.ownerDocument.createRange();
        try {
            nodeRange.selectNode(node);
        } catch (e) {
            nodeRange.selectNodeContents(node);
        }

        return range.compareBoundaryPoints(Range.END_TO_START, nodeRange) === -1 &&
            range.compareBoundaryPoints(Range.START_TO_END, nodeRange) === 1;
    };

function applyClassToSelection(cssClass) {
    //var uniqueCssClass = "selection_" + (++nextId);
    var sel = window.getSelection();
    if (sel.rangeCount < 1) {
        return;
    }
    var range = sel.getRangeAt(0);
    var startNode = range.startContainer, endNode = range.endContainer;

    // Split the start and end container text nodes, if necessary
    if (endNode.nodeType === 3) {
        endNode.splitText(range.endOffset);
        range.setEnd(endNode, endNode.length);
    }

    if (startNode.nodeType === 3) {
        startNode = startNode.splitText(range.startOffset);
        range.setStart(startNode, 0);
    }

    // Create an array of all the text nodes in the selection
    // using a TreeWalker
    var containerElement = range.commonAncestorContainer;
    if (containerElement.nodeType !== 1) {
        containerElement = containerElement.parentNode;
    }

    var treeWalker = document.createTreeWalker(
        containerElement,
        NodeFilter.SHOW_TEXT,
        // Note that Range.intersectsNode is non-standard but
        // implemented in WebKit
        function(node) {
            return rangeIntersectsNode(range, node) ?
                NodeFilter.FILTER_ACCEPT : NodeFilter.FILTER_REJECT;
        },
        false
    );

    var selectedTextNodes = [];
    while (treeWalker.nextNode()) {
        selectedTextNodes.push(treeWalker.currentNode);
    }

    var textNode, span;

    // Place each text node within range inside a <span>
    // element with the desired class
    for (var i = 0, len = selectedTextNodes.length; i < len; ++i) {
        textNode = selectedTextNodes[i];
        span = document.createElement("span");
        span.className = cssClass; // + " " + uniqueCssClass;
        textNode.parentNode.insertBefore(span, textNode);
        span.appendChild(textNode);
    }

    return; // uniqueCssClass;
}

function applyFontSizeToSelection(size) {
    //var uniqueCssClass = "selection_" + (++nextId);
    var sel = window.getSelection();
    if (sel.rangeCount < 1) {
        return;
    }
    var range = sel.getRangeAt(0);
    var startNode = range.startContainer, endNode = range.endContainer;

    // Split the start and end container text nodes, if necessary
    if (endNode.nodeType === 3) {
        endNode.splitText(range.endOffset);
        range.setEnd(endNode, endNode.length);
    }

    if (startNode.nodeType === 3) {
        startNode = startNode.splitText(range.startOffset);
        range.setStart(startNode, 0);
    }

    // Create an array of all the text nodes in the selection
    // using a TreeWalker
    var containerElement = range.commonAncestorContainer;
    if (containerElement.nodeType !== 1) {
        containerElement = containerElement.parentNode;
    }

    var treeWalker = document.createTreeWalker(
        containerElement,
        NodeFilter.SHOW_TEXT,
        // Note that Range.intersectsNode is non-standard but
        // implemented in WebKit
        function(node) {
            return rangeIntersectsNode(range, node) ?
                NodeFilter.FILTER_ACCEPT : NodeFilter.FILTER_REJECT;
        },
        false
    );

    var selectedTextNodes = [];
    while (treeWalker.nextNode()) {
        selectedTextNodes.push(treeWalker.currentNode);
    }

    var textNode, span;

    // Place each text node within range inside a <span>
    // element with the desired class
    for (var i = 0, len = selectedTextNodes.length; i < len; ++i) {
        textNode = selectedTextNodes[i];
        span = document.createElement("span");
        span.style.fontSize = size+"px";
        textNode.parentNode.insertBefore(span, textNode);
        span.appendChild(textNode);
    }

    return;  
}

function applyFontColorToSelection(color) {
    //var uniqueCssClass = "selection_" + (++nextId);
    var sel = window.getSelection();
    if (sel.rangeCount < 1) {
        return;
    }
    var range = sel.getRangeAt(0);
    var startNode = range.startContainer, endNode = range.endContainer;

    // Split the start and end container text nodes, if necessary
    if (endNode.nodeType === 3) {
        endNode.splitText(range.endOffset);
        range.setEnd(endNode, endNode.length);
    }

    if (startNode.nodeType === 3) {
        startNode = startNode.splitText(range.startOffset);
        range.setStart(startNode, 0);
    }

    // Create an array of all the text nodes in the selection
    // using a TreeWalker
    var containerElement = range.commonAncestorContainer;
    if (containerElement.nodeType !== 1) {
        containerElement = containerElement.parentNode;
    }

    var treeWalker = document.createTreeWalker(
        containerElement,
        NodeFilter.SHOW_TEXT,
        // Note that Range.intersectsNode is non-standard but
        // implemented in WebKit
        function(node) {
            return rangeIntersectsNode(range, node) ?
                NodeFilter.FILTER_ACCEPT : NodeFilter.FILTER_REJECT;
        },
        false
    );

    var selectedTextNodes = [];
    while (treeWalker.nextNode()) {
        selectedTextNodes.push(treeWalker.currentNode);
    }

    var textNode, span;

    // Place each text node within range inside a <span>
    // element with the desired class
    for (var i = 0, len = selectedTextNodes.length; i < len; ++i) {
        textNode = selectedTextNodes[i];
        span = document.createElement("span");
        span.style.color = color;
        textNode.parentNode.insertBefore(span, textNode);
        span.appendChild(textNode);
    }
    
    range.collapse(false);
    sel.removeAllRanges();
    sel.addRange(range);

    return;  
}


function stopGifAnimations() {
  
    var images = [];
    var class_name = "freezeframe";
    images = $('img[class*="' + class_name + '"]')
			.not('[class*="' + class_name + '_done"]');
   app.log("stopGifAnimations running on "+images.size());             
   $(images).each(function(index) {
       $(this).removeClass(class_name).addClass(class_name + "_done");
        freeze_gif(this);
   });
}

   

function freeze_gif(i) {
     
    app.log("freeze_gif: "+i.src);
    var c = document.createElement('canvas');
    var w = c.width = i.width;
    var h = c.height = i.height;
    
    c.getContext('2d').drawImage(i, 0, 0, w, h);     

    var d = document.createElement('div');
    d.appendChild(c);    
    d.setAttribute('style', "display: inline; text-align:center;"); 
    
    i.parentNode.replaceChild(d, i); 

    var animating = false;
    
    $(d).mouseenter(function() {	         
        if (animating) return;
        d.replaceChild(i, c); 
        animating = true;        
    });
    
    $(i).mouseleave(function() {
        i.parentNode.replaceChild(c, i); 
        animating = false;
    });
}

